local scene = {}
local love = assert( love )
local mt = {}

local function loadScene( scene )
  print( "Loading Scene:", scene.name )
  for k, v in pairs( scene ) do
    love[k] = v
  end
  scene.onLoad()
end

local function newScene( scenes, name, t )
  t.name = t.name or name
  print( "Adding Scene:", t.name )
  setmetatable( t, { __call = function() return loadScene( t ) end } )
  rawset( scenes, name, t )
end

return setmetatable( scene,
  {__call = loadScene,
  __newindex = newScene
  } )