local shared = assert( require 'shared' )
local socket = assert( require 'socket' )
local udp = socket.udp()
local io = assert( io )
local server = {
  tick = 0,
  portNumber = 51312,
  logFile = assert( io.open( "../logs/dajjal"..os.time()..".txt", "a" )),
  serverName = "dajjal-server",
}

local clients = {
  
}

do
  local _print = print
  function server.Print(...)
    _print( ... )
    server.logFile:write( table.concat({os.date("!%Y-%m-%d %X"), ...}, "\t"), "\n" )
    server.logFile:flush()
  end
end
local print = server.Print


--Developer convenience function: start the local client program.
function server.StartLocalClient()
  os.execute( "start vision.bat" )
end

--Incoming packet.
function server.Parse( packet, ip, port )
  if not packet then return end
  print( packet, ip, port )
  return server.Parse( udp:receivefrom() ) -- Process any packets we missed.
end

function server.Start()
  udp:settimeout(0)
  udp:setsockname('*', server.portNumber)
  print( "Starting Server" )
  server.StartLocalClient()
  repeat
    server.Parse( udp:receivefrom() )
    server.Advance()
  until socket.sleep( 0.1 - (socket.gettime() % 0.1) )
end

function server.Advance()
  server.tick = server.tick + 1
  for id, client in ipairs( clients ) do
    udp:sendto( string.format("server: %d client: %d", server.tick, client.tick), client.ip, client.port)
  end
end

function server.NewGame()
  server.tick = 0
end

function server.Quit()

end

return server.Start()